library ieee;
use ieee.std_logic_1164.all;
entity afficheur_BCD_hex0 is
port (
		N : in std_logic_vector (3 downto 0);
		HEX : out std_logic_vector (6 downto 0));
end afficheur_BCD_hex0;
architecture arch_afficheur of afficheur_BCD_hex0 is
begin
process (N)
begin
 case N is-- commande HEXments gfedcba
when "0000" => HEX <= "1000000";
when "0001" => HEX <= "1111001";
when "0010" => HEX <= "0100100";
when "0011" => HEX <= "0110000";
when "0100" => HEX <= "0011001";
when "0101" => HEX <= "0010010";
when "0110" => HEX <= "0000010";
when "0111" => HEX <= "1111000";
when "1000" => HEX <= "0000000";
when "1001" => HEX <= "0010000";
when others => HEX <= "0000110";
end case;
end process;
end arch_afficheur;

library ieee;
use ieee.std_logic_1164.all;
package afficheur_BCD_hex0_package is
component afficheur_BCD_hex0
port(
N : in std_logic_vector (3 downto 0);
HEX : out std_logic_vector (6 downto 0));	
end component;
end afficheur_BCD_hex0_package;


LIBRARY IEEE;
USE  IEEE.STD_LOGIC_1164.all;
USE  IEEE.STD_LOGIC_ARITH.all;
USE  IEEE.STD_LOGIC_UNSIGNED.all;
use work.afficheur_BCD_hex0_package.all;

-- ce code affiche l?heure sur 7 afficheurs
--  ici Key2  reset l?affichage
ENTITY RTC_VHDL IS
	PORT( CLOCK_50				: IN	STD_LOGIC;
			SW : in std_logic_vector (17 downto 0);	-- SW(0) est le reset
			KEY : in std_logic_vector (3 downto 0);
			HEX0 : out std_logic_vector (6 downto 0);
			HEX1 : out std_logic_vector (6 downto 0);
			HEX2 : out std_logic_vector (6 downto 0);
			HEX3 : out std_logic_vector (6 downto 0);
			HEX4 : out std_logic_vector (6 downto 0);
			HEX5 : out std_logic_vector (6 downto 0);
			HEX6 : out std_logic_vector (6 downto 0);
			HEX7 : out std_logic_vector (6 downto 0));
				 
END RTC_VHDL;

ARCHITECTURE a OF RTC_VHDL IS
	SIGNAL CLK_COUNT_10HZ: STD_LOGIC_VECTOR(23 DOWNTO 0);
	SIGNAL CLK_COUNT_1HZ: STD_LOGIC_VECTOR(3 DOWNTO 0);
	SIGNAL BCD_SECD0,BCD_SECD1,BCD_MIND0,BCD_MIND1: STD_LOGIC_VECTOR(3 DOWNTO 0);
	SIGNAL BCD_HRD0,BCD_HRD1,BCD_DSEC: STD_LOGIC_VECTOR(3 DOWNTO 0);
	SIGNAL CLK_400HZ, CLK_10HZ, CLK_1HZ : STD_LOGIC;
	SIGNAL RESET,HUP,HDO,MUP,MDO : STD_LOGIC;
BEGIN
--envoie des donnes sur les afficheurs	
	affich1:afficheur_BCD_hex0 port map (BCD_DSEC,HEX1);
	affich2:afficheur_BCD_hex0 port map (BCD_SECD0,HEX2);
	affich3:afficheur_BCD_hex0 port map (BCD_SECD1,HEX3);
	affich4:afficheur_BCD_hex0 port map (BCD_MIND0,HEX4);
	affich5:afficheur_BCD_hex0 port map (BCD_MIND1,HEX5);
	affich6:afficheur_BCD_hex0 port map (BCD_HRD0,HEX6);
	affich7:afficheur_BCD_hex0 port map (BCD_HRD1,HEX7);
	RESET <= SW(0);
	HUP <= KEY(3); -- heure ++
	HDO <= KEY(2); -- heure --
	MUP <= KEY(1); -- minute ++
	MDO <= KEY(0); -- minute --
	HEX0 <= B"1111111"; -- efface afficheur de droite
	
	PROCESS
	BEGIN
	 WAIT UNTIL CLOCK_50'EVENT AND CLOCK_50 = '1';
		IF RESET = '0' THEN
		 CLK_COUNT_10HZ <= X"000000";
		 CLK_10HZ <= '0';
		ELSE
				IF CLK_COUNT_10HZ < X"2625A0" THEN --
				 CLK_COUNT_10HZ <= CLK_COUNT_10HZ + 1;
				ELSE
		    	 CLK_COUNT_10HZ <= X"000000";
				 CLK_10HZ <= NOT CLK_10HZ;
						IF CLK_COUNT_1HZ < X"A" THEN --
							CLK_COUNT_1HZ <= CLK_COUNT_1HZ + 1;
						ELSE
							CLK_COUNT_1HZ <= X"0";
							CLK_1HZ <= NOT CLK_1HZ;
						END IF;
				END IF;
		END IF;
	END PROCESS;
	
-- reglage heure et inutes
-- a finir
 PROCESS (Clk_1hz)
 BEGIN
 	IF clk_1HZ'EVENT AND clk_1HZ = '1' THEN
		IF HUP = '0' THEN
	--		BCD_HRD1 <= X"0";
		END IF;END IF;
 END PROCESS;

	PROCESS (Clk_10hz, reset)
	BEGIN
		IF reset = '0' THEN	
			BCD_HRD1 <= X"1";			
			BCD_HRD0 <= X"8";
			BCD_MIND1 <= X"1";
			BCD_MIND0 <= X"9";
			BCD_SECD1 <= X"0";
			BCD_SECD0 <= X"0";
			BCD_DSEC  <= X"0";

		ELSIF clk_10HZ'EVENT AND clk_10HZ = '1' THEN

-- 1/10 de secondes
		IF BCD_DSEC < 9 THEN
		 BCD_DSEC <= BCD_DSEC + 1;
		ELSE
		 BCD_DSEC <= X"0";
-- secondes
		IF BCD_SECD0 < 9 THEN
	 	 BCD_SECD0 <= BCD_SECD0 + 1;
		ELSE
-- dizaines de secondes
		 BCD_SECD0 <= "0000";
	 	  IF BCD_SECD1 < 5 THEN
	  	 BCD_SECD1 <= BCD_SECD1 + 1;
	 	 ELSE
-- MINUTES
	  	 BCD_SECD1 <= "0000";
	  	 IF BCD_MIND0 < 9 THEN
	   	  BCD_MIND0 <= BCD_MIND0 + 1;
	  	 ELSE
-- DIZAINES DE MINUTES
	   	  BCD_MIND0 <= "0000";
	   	  IF BCD_MIND1 < 5 THEN
	       BCD_MIND1 <= BCD_MIND1 + 1;
	   	  ELSE
-- HEURES
	    	BCD_MIND1 <= "0000";
	    	IF BCD_HRD0 < 9 AND NOT((BCD_HRD1 = 2) AND (BCD_HRD0 = 3))THEN
	     	 BCD_HRD0 <= BCD_HRD0 + 1;
	    	ELSE
-- DIZAINES DE HEURES
	     	 IF NOT((BCD_HRD1 = 2) AND (BCD_HRD0 = 3)) THEN
	      	  BCD_HRD1 <= BCD_HRD1 + 1;
	      	  BCD_HRD0 <= "0000";
	     	 ELSE
-- NOUVELLE JOURNEE
	      	 BCD_HRD1 <= "0000";
          	 BCD_HRD0 <= "0000";
         	END IF;
           END IF;
          END IF;
         END IF;
        END IF;
       END IF;
	 END IF;
	END IF;
 END PROCESS;
END a;

